



#include "OmSourceParameters.h"


#include "Dal.h"
#include "astrometrydefs.h"
#include "utility.h"
#include <iostream>
#include <iomanip>


/************************************************************
*
************************************************************/
bool compare(const matchedData &a, const matchedData & b)
{
    return a.distance < b.distance;

};



/************************************************************
*
************************************************************/
bool compare1(const data &a, const data & b)
{
    return a.ra < b.ra;

};


/************************************************************
*
************************************************************/
bool compare2(const OmSourceParameter &a, const OmSourceParameter & b)
{
    return a.rightascension < b.rightascension;

};




/************************************************************
*
************************************************************/

double EquatorialCoordinates::arcLength( EquatorialCoordinates & a)
{

    return acos( min( 1.0, (x * a.x + y * a.y + z * a.z))) * radiansToArcSecs;


};

/*****************************************************
*
* Computes the equatorial rectangular coordinates
*
*****************************************************/
EquatorialCoordinates::EquatorialCoordinates(double raIn, double decIn)
{
    ra = raIn;
    dec = decIn;

    computeEquatorialCoordinates();


};



/*****************************************************
*
* Computes the equatorial rectangular coordinates
*
*****************************************************/
EquatorialCoordinates::EquatorialCoordinates(double xIn, double yIn, double zIn)
{
    x = xIn;
    y = yIn; 
    z = zIn;

    computeSphericalCoordinates();


};




/*****************************************************
*
*
*
*****************************************************/
EquatorialCoordinates::EquatorialCoordinates(const EquatorialCoordinates &e)
{
    x = e.x;
    y = e.y; 
    z = e.z;
    ra = e.ra;
    dec = e.dec;
   


};
















/*******************************************************************
*
*
*******************************************************************/
void EquatorialCoordinates::computeEquatorialCoordinates()
{

 
    double cosDec = cos( dec );

    x = cosDec * cos( ra );
    y = cosDec * sin( ra );
    z = sin( dec );
           



};
    
/**************************************************************
*
**************************************************************/    
void EquatorialCoordinates::computeSphericalCoordinates()
{
       
    double delta = sqrt(x * x + y * y + z * z);
    
    if( x == 0.0 and y == 0.0)
    {
        ra = 0.0;


    }
    else if(x == 0.0 and y > 0.0)
    {
        ra = M_PI / 2.0;

    } 
    
    else if( x < 0.0 and y == 0.0)
    { 
   
        ra = M_PI;
    }    
    else if( x == 0.0 and y < 0.0)
    { 
   
        ra = 1.5 * M_PI;
    }


    else    
    {


        
	ra = abs( atan2(y, x));  
       
	if(y < 0.0) 
	{
	    ra = 2.0 * M_PI - ra;
               
        }; 
        
    }

    if( abs(z) > 0.0)
        dec = asin( z / delta);
    else
	dec = 0.0;  
           
    



};










