 
module convert_mod
use dal
use sla
use cal
use getFilterID_mod

use omconstants_mod
public
contains

!*****************************************************************
!
!
!*****************************************************************

subroutine convert1(x, y, ra0, dec0, ra, dec)
    real(double), intent(in) :: x, y, ra0, dec0
    real(double), intent(out) :: ra, dec


    call sla_dtp2s(x, y, ra0, dec0, ra, dec)

    ra = ra * radiansToDegrees
    dec = dec * radiansToDegrees


end subroutine convert1

!*****************************************************************
!
!
!*****************************************************************

subroutine convert3(x, y, ra0, dec0, ra, dec)

    real(double), intent(in) :: x, y, ra0, dec0
    real(double), intent(out) :: ra, dec

    call sla_dtp2s(x, y, ra0, dec0, ra, dec)

  
end subroutine convert3



!*****************************************************************
!
!
!
!
!*****************************************************************
subroutine convert2(ra, dec, ra0, dec0, x, y)
    real(double), intent(in) :: ra, dec, ra0, dec0
    real(double), intent(out) :: x, y
    integer :: k = 0

    k = 0;
    call sla_ds2tp(ra * degreesToRadians, dec * degreesToRadians,  &
                  ra0, dec0, x, y, k)

    if (k .ne. 0) then
        call fatal("Error calling sla_ds2tp!")

    end if
    x = x * radiansToDegrees
    y = y * radiansToDegrees


end subroutine convert2

!***********************************************************
!
!
!
!**********************************************************
real(double) Function getplatescale()


    integer :: filterIdInt


    !  Get the filter Id integer value
    filterIdInt = filterIdToInt("V")

    call CAL_setState(OM, filterId = filterIdInt)

 
    ! Get the Plate scale (arcsecs/pixel)
    call CAL_omGetPlateScale(0.55_double, getplateScale)
    




end function getplatescale




 
end module convert_mod





