#ifndef MATCHLISTS_H
#define MATCHLISTS_H
#include "astrometrydefs.h"
#include<vector>
class data;
class matchedData;

/*********************************************************************
*
* A class for matching 2 source-lists using RA and DEC coordinates
*
**********************************************************************/
class MatchLists
{
    public:
        MatchLists() {};
        MatchLists(vector<data> &listData, vector<data> &catData) 
	  : _listData(listData), _catData(catData) {}; 

        ~MatchLists() {};

        void matchLists(double tolerance);

        vector<vector<matchedData> >& getMatchedSource() { return  _matchedSource; };  
        int getMatches(double tolerance, vector<data> &_matchedListData, vector<data> &_matchedCatData);
        int getAllMatches(double tolerance, vector<data> &_matchedListData, vector< vector<data> > &matchedCatData);
        void computeOffsets( vector<data> &matchedListData, vector<data> &matchedCatData);
        double getRAMeanOffset() { return _raMeanOffset; };
        double getDecMeanOffset() { return _decMeanOffset; };
        void removeOffsets();


    private:
     
	vector<data> _listData, _catData;
        vector< vector<matchedData> > _matchedSource;
        double _raMeanOffset;
        double _decMeanOffset;
        double _mean, _median;
        double _point05Percentile, _point95Percentile;

};
#endif
