#ifndef OMMERGELISTS_DEFS_H
#define OMMERGELISTS_DEFS_H



#include <f90cxx.h>
#include<vector>
#include "Dal.h"
class OmSourceParameter;



void setCorrectedCoordinates(Table *table,  
                             vector < OmSourceParameter > &srcList2,
                             vector<int> &rowNums, vector<int> &unmatchedIndex2);





void checkSignificances(Table *table, Table *updateTable, 
                        vector<int> &matchedIndex1, 
                        vector<int> &matchedIndex2, 
                        map<string, vector<int> > rowFilled);



void plotData3(vector<string> &filterList, string xLabel, string yLabel, string title, string columnName, 
              Table *table1, vector < int >  &matchedIndex1, 
	       Table *table2, vector < int >  &matchedIndex2 );






void checkFiles(string &srcFile1, string &srcFile2);



/*****************************************************************************
* Sets the data value in the merged table at row number rowNums[i] to the
* value in the update table at row number updateNums[i]
* This is specialised for char *
*
******************************************************************************/

void fillData( char * data, vector<int> &rowNums, char * newData, 
               vector<int> &updateNums, int width, 
               vector<int> &filled,
               int fillNumber )
{     
  
    for (unsigned i = 0; i < rowNums.size(); i++)
    {


        int j = rowNums[i];
        int k = updateNums[i];
        if( filled[j] ) continue;
    



        if( filled[j] ) continue;     // Already set the valie of this column
        filled[ j] = fillNumber;
        for(int l = 0; l < width; l++)
        {
            data[ j * width + l ]  =  newData[ k * width + l];
        
        }  
     
    }
}

/*****************************************************************
*
* This is for ints, etc
* Fills the data in a table column
* The number of rows to fill is given by the size of rownums
* rownums is the list of rows to update using data in the array newdata
*
******************************************************************/
template<class T>
void fillData( T * data, vector<int> &rowNums, T * newData, 
               vector<int> &updateNums, 
               vector<int> &filled, int fillNumber )
{     

    for (unsigned i = 0; i < rowNums.size(); i++)
    {
        int j = rowNums[i];
        int k = updateNums[i];
        if( filled[j] ) continue;
        if( !isNull( newData[k] ) )
	{

	  //	    if(fillNumber == 2)
	  // {
	  //    cout << "Filled row number fill number=" << fillNumber << " j="  << j << " old value=" << data[j] << " new=" << newData[k] << endl;
          //  } 
            filled[j] = fillNumber;
            data[j] =   newData[ k ];

        }
    }   

}










void checkFileExists( string file);



void addSkyImageColumn(Table *table, string name, vector<string> &text);



void addSkyImageColumns(Table *table, map<string, vector<int> > &rowFilled);




void setRADecColumns(Table *table, vector<int> &index);

void removeColumns(Table *table);


void  checkNewRateColumns(Table *table, vector<int> &index);




void createMergedFile( vector<int> &index, vector<int> &index1, 
                       vector<int> &index2, vector<int> & index3,     
                       vector < OmSourceParameter > &srcList2);

void fillTable( Table * table,  vector<int> &rowNums, Table *updateTable, 
               vector<int> &updateNums, map<string, vector<int> > &filled, int fillNumber );

void compareMatches( vector<data> &matchedListData, vector<data> &matchedCatData);




void compareMatches( vector < OmSourceParameter > &srcList1,
                     vector < int > &matchedIndex1,
                     vector < OmSourceParameter > &srcList2,
                     vector < int > &matchedIndex2);




int getType( string file );
void loadObsSourceParameters( string file,   vector < OmSourceParameter > &srcList);
void compareMatchedSignificances( vector < OmSourceParameter > &srcList1,
                 vector < OmSourceParameter > &srcList2,
                 vector < int > &matchedIndex1, 
                 vector < int > &matchedIndex2,  
		 vector < int > &unmatchedIndex2);

void removeUnusedRows(Table *table, vector<bool> &used);

void addColumn(Column *column, Table *table);





/***********************************************************
*
*
***********************************************************/
void checkPixels(int nx, int ny, int j, int k, int noFlags, 
		 vector<vector<int16> > &qualityImage, int16 &source);





F90MODPROCPROTO( void, convert_mod, convert1)(double *, double *, double *, double*, double *, double *);
F90MODPROCPROTO( void, convert_mod, convert2)(double *, double *, double *, double*, double *, double *);
F90MODPROCPROTO( int, flags_mod, getnoqualityflags)();
F90MODPROCPROTO( void, flags_mod, getqualityflag)(int *, int *, char[200]);




void matchLists( vector < OmSourceParameter > &srcList1,
                 vector < OmSourceParameter > &srcList2,
                 vector < int > &matchedIndex1,
                 vector < int > &matchedIndex2,
                 vector < int > &unmatchedIndex1,
                 vector < int > &unmatchedIndex2);




void createRegionfile(string file, const vector<OmSourceParameter> & sources, 
		      const vector<string> &colour,  const bool showNumbers);





void addNewColumns(Table *table, Table *updateTable, vector<string> &newColumnList);



void loadData(string srcFile,  vector < OmSourceParameter > &srcList, int type);

/**********************************************************************
*
*
* This is for comparing properties between the two lists of matched sources
*
***********************************************************************/
void compareMatches( string file1, 
                     vector < OmSourceParameter > &srcList1,
                     vector < int >  &matchedIndex1,
                     string file2, 
                     vector < OmSourceParameter > &srcList2,
                     vector < int >   &matchedIndex2);



void plotData1(vector<string> &filterList, string xLabel, string yLabel, string title, string columnName, 
              Table *table1, vector < int >  &matchedIndex1, 
	      Table *table2, vector < int >  &matchedIndex2 );


void plotData2(vector<string> &filterList, string xLabel, string yLabel, string title, 
              Table *table1, vector < int >  &matchedIndex1, 
	       Table *table2, vector < int >  &matchedIndex2 );




void setNulls(Table *table);
void setNulls(Table *table, string filter, int i);


void plotStatistics(vector<float> &x, string text);


void  refineMatchedList(const string file, vector<int> &matchedIndex);


#endif
