
#include <iostream>
#include <Dal.h>
#include "astrometrydefs.h"
#include "sourcelist.h"
#include <vector>
#include <algorithm>
#include "sorttable.h"

/*************************************************************************
*
*
**************************************************************************/
using namespace std;
void sortTable( string file )
{


    DataSet *dataSet = dataSetServer->open(file, Dal::Modify);
    if (!dataSet) return ;    


    

    Table *tableH = dataSet->table("SRCLIST");
  
    sortTable( &tableH );


    dataSetServer->close(dataSet); // Finished with the file





}
/*******************************************************************
*
*
*
********************************************************************/
void sortTable( Table **tableH )
{
 
    int nRows = (*tableH)->rows();


    if(nRows < 2)
    {
        return;
    }


    /**********************************************************
    * 
    *
    *********************************************************/
    vector<double> ra;

    if( (*tableH)->hasColumn("RA_CORR") ) 
    {
        int size = 0; 
        if ( !LoadVectorDoubleColumnData( *tableH, "RA_CORR", size, ra))
	{
        }
    }
    else
    {
        int size = 0;
        if ( !LoadVectorDoubleColumnData( *tableH, "RA", size, ra) )
	{
        }


    }

    vector<OmSourceParameter> sourceList(nRows);

    for(int i = 0; i < nRows; i++)
    {
        sourceList[i].rightascension = ra[i];
        sourceList[i].number = i;
  

    }

    vector<int> raSortIndex(nRows);   

 
    /*****************************************************
    * Find the order of increasing  RA- store in RASortIndex
    * for adding data to source list table in  
    * increasing RA order (ra is not sorted)
    *****************************************************/
    sort(sourceList.begin(), sourceList.end(), compare2);

    for(int i = 0; i < nRows; i++)
    {
 
        raSortIndex[i] = sourceList[i].number; 
    }

    //    cout << "Sorttable line the sorted data 74\n";

    //  for(int i = 0; i < nRows; i++)
    //   cout << i << ") ra=" << sourceList[i].rightascension << " index=" << raSortIndex[i] << endl;



    (*tableH)->insertRows( nRows,  nRows );
    (*tableH)->copyRows( 0, nRows, nRows );

    /*************************************************************
    * Reorder the table into increasing RA order
    **************************************************************/
  

    for(int i = 0; i <  nRows; i++)
    {
        int k = raSortIndex[i] + nRows;       
	//	cout << i << ") k=" << k << " rasortindex=" << raSortIndex[i] << endl;
        (*tableH)->copyRows(k, i, 1);
    }


    /********************************************************
    *
    * Delete the appended temporary rows
    *
    *********************************************************/


    (*tableH)->deleteRows( nRows, nRows);
 
    



 }
